﻿Imports Telerik.Web.UI
Imports System.Data
Imports System.Data.SqlClient
Imports System.Threading

Partial Class Combobox_Default
    Inherits System.Web.UI.Page

    Private Const ItemsCategorie As Integer = 10

    Protected Sub Categoria_ItemsRequested(sender As Object, e As Telerik.Web.UI.RadComboBoxItemsRequestedEventArgs) Handles Categoria.ItemsRequested

        Dim data As DataTable = GetDataCategoria(e.Text)

        Dim itemOffset As Integer = e.NumberOfItems

        Dim endOffset As Integer = Math.Min(itemOffset + ItemsCategorie, data.Rows.Count)

        e.EndOfItems = endOffset = data.Rows.Count


        For i As Integer = itemOffset To endOffset - 1

            Categoria.Items.Add(New RadComboBoxItem(data.Rows(i)("CompanyName").ToString(), data.Rows(i)("CompanyName").ToString()))

        Next

        e.Message = GetStatusMessageCategoria(endOffset, data.Rows.Count)

    End Sub
    Private Shared Function GetDataCategoria(text As String) As DataTable

        Dim adapter As New SqlDataAdapter("SELECT * from Customers WHERE CompanyName LIKE @text + '%'", ConfigurationManager.ConnectionStrings("NorthwindConnectionString35").ConnectionString)
        adapter.SelectCommand.Parameters.AddWithValue("@text", text)

        Dim data As New DataTable()

        adapter.Fill(data)

        Return data

    End Function

    Private Shared Function GetStatusMessageCategoria(offset As Integer, total As Integer) As String

        If total <= 0 Then

            Return "No records"

        End If

        Return [String].Format("Items: <b>1</b>-<b>{0}</b> out of <b>{1}</b>", offset, total)

    End Function


End Class
